import { FormAssociated } from "../form-associated/index";
export interface RadioControl {
    checked: boolean;
    disabled: boolean;
    readOnly: boolean;
    focus: () => void;
    setAttribute: (name: string, value: string) => void;
    getAttribute: (name: string) => string | null;
}
export declare class Radio extends FormAssociated<HTMLInputElement> implements RadioControl {
    readOnly: boolean;
    private readOnlyChanged;
    name: string;
    protected nameChanged(): void;
    /**
     * The element's value to be included in form submission when checked.
     * Default to "on" to reach parity with input[type="radio"]
     */
    value: string;
    private valueChanged;
    /**
     * Provides the default checkedness of the input element
     * Passed down to proxy
     */
    checkedAttribute: boolean;
    private checkedAttributeChanged;
    defaultSlottedNodes: Node[];
    /**
     * Initialized to the value of the checked attribute. Can be changed independently of the "checked" attribute,
     * but changing the "checked" attribute always additionally sets this value.
     */
    defaultChecked: boolean;
    private defaultCheckedChanged;
    /**
     * The checked state of the control
     */
    checked: boolean;
    private checkedChanged;
    protected proxy: HTMLInputElement;
    /**
     * Tracks whether the "checked" property has been changed.
     * This is necessary to provide consistent behavior with
     * normal input radios
     */
    private dirtyChecked;
    constructor();
    connectedCallback(): void;
    private updateForm;
    keypressHandler: (e: KeyboardEvent) => void;
    clickHandler: (e: MouseEvent) => void;
}
