import { __decorate } from "tslib";
import { attr, booleanConverter, FASTElement } from "@microsoft/fast-element";
import { StartEnd } from "../patterns/start-end";
import { applyMixins } from "../utilities/apply-mixins";
export var MenuItemRole;
(function (MenuItemRole) {
    MenuItemRole["menuitem"] = "menuitem";
    MenuItemRole["menuitemcheckbox"] = "menuitemcheckbox";
    MenuItemRole["menuitemradio"] = "menuitemradio";
})(MenuItemRole || (MenuItemRole = {}));
export class MenuItem extends FASTElement {
    constructor() {
        super(...arguments);
        this.expanded = false;
        this.role = MenuItemRole.menuitem;
        this.handleMenuItemKeyDown = (e) => {
            this.change();
            return true;
        };
        this.handleMenuItemClick = (e) => {
            this.change();
        };
        this.change = () => {
            this.$emit("change");
        };
    }
}
__decorate([
    attr({ mode: "boolean" })
], MenuItem.prototype, "disabled", void 0);
__decorate([
    attr({ attribute: "aria-expanded", mode: "reflect", converter: booleanConverter })
], MenuItem.prototype, "expanded", void 0);
__decorate([
    attr
], MenuItem.prototype, "role", void 0);
__decorate([
    attr
], MenuItem.prototype, "checked", void 0);
applyMixins(MenuItem, StartEnd);
